import cocotb
from cocotb.triggers import RisingEdge, Timer
from cocotb.clock import Clock

import math

import numpy as np
import imageio.v3 as iio

@cocotb.test()
async def main_test(dut):
    dut._log.info("Starting test") 

    cocotb.start_soon(Clock(dut.clk, 20, units='ns').start())
    await Timer(50, units='ns')
    
    im = iio.imread('kodim23-small.png')
    out_img = np.empty(im.shape, dtype='uint8')

    dut.img_r_in.value = 0
    dut.img_g_in.value = 0
    dut.img_b_in.value = 0
    await Timer(20, units='ns')

    c = 0
    r = 0
    for col in im:
        dut._log.info("kol %s"%c)
        r=0

        for row in col:
            dut.img_r_in.value = int(row[0])
            dut.img_g_in.value = int(row[1])
            dut.img_b_in.value = int(row[2])

            await RisingEdge(dut.clk)

            out_img[c][r][0] = dut.img_r_out.value
            out_img[c][r][1] = dut.img_g_out.value
            out_img[c][r][2] = dut.img_b_out.value
        
            r = r+1

        c = c+1
        #try:
        #    dut._log.info("%s"%s_out)
        #    sock.sendto(struct.pack('I',s_out),('localhost', 5000))
        #except:
        #    pass
    iio.imwrite("kodim23-output.png", out_img,extension='.png')
    dut._log.info("test done")
                      
