import cocotb
from cocotb.triggers import RisingEdge, Timer
from cocotb.clock import Clock

import math

import socket
import struct

@cocotb.test()
async def main_test(dut):
    dut._log.info("Starting test") 

    cocotb.start_soon(Clock(dut.clk, 20, units='ns').start())

    sock = socket.socket(socket.AF_INET,
                         socket.SOCK_DGRAM)
                         
    dut.sine_in.value = 0
 
    await Timer(20, units='ns')

    for i in range(1800):
        s = int(math.sin(math.degrees(i/1000))*1000)
        dut.sine_in.value = s

        await RisingEdge(dut.clk)

        s_out = dut.sine_out.value
        await Timer(20, units='us')
        try:
            dut._log.info("%s"%s_out)
            sock.sendto(struct.pack('I',s_out),('localhost', 5000))
        except:
            pass
        
    dut._log.info("test done")
                      
